/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor ustocz.c */

#include "struktury.h"
#include "lib.h"

int us_k[] =
    { '<', '>', '/', '?', ';', /**/ ':', '\'', '"', '[', '{', /**/
']', '}', '`', '~', '1', /**/ '!', '2', '@', '3', '#', /**/
'4', '$', '5', '%', '6', /**/ '^', '7', '&', '8', '*', /**/
'9', '(', '0', ')', '-', /**/ '_', '=', '+'
};

int cz_k[] =
    { '?', ':', '-', '_', '', /**/ '"', '', '!', '', '/', /**/
')', '(', '`', ';', '+', /**/ '1', '', '2', '', '3', /**/
'', '4', '', '5', '', /**/ '6', '', '7', '', '8', /**/
'', '9', '', '0', '=', /**/ '%', '\'', ''
};

/* carka */
int us_c[] =
    { 'a', 'e', 'i', 'o', 'u', 'y', 'A', 'E', 'I', 'O', 'U', 'Y' };
int cz_c[] =
    { '', '', '', '', '', '', '', '', '', '', '', '' };
/* hacek */
int us_h[] =
    { 'c', 'C', 'd', 'D', 'e', 'E', 'n', 'N', 'r', 'R', 's', 'S', 't', 'T',
    'U', 'u', 'z', 'Z'
};

int cz_h[] =
    { '', '', '', '', '', '', '', '', '', '', '', '', '', '',
    '', '', '', ''
};

int ustocz(int ch)
{
    int i;
    static char carka_hacek = 'x';

    if (carka_hacek == 'c') {
        carka_hacek = 'x';
        for (i = 0; i < sizeof(us_c) / sizeof(us_c[0]); i++)
            if (ch == us_c[i])
                return cz_c[i];

        return '\'';
    }

    if (carka_hacek == 'h') {
        carka_hacek = 'x';
        for (i = 0; i < sizeof(us_h) / sizeof(int); i++)
            if (ch == us_h[i])
                return cz_h[i];

        return '^';
    }

    for (i = 0; i < sizeof(us_k) / sizeof(int); i++)
        if (ch == us_k[i]) {
            ch = cz_k[i];
            break;
        }

    if (ch == '\'') {
        carka_hacek = 'c';
        return '\0';
    }

    if (ch == '') {
        carka_hacek = 'h';
        return '\0';
    }

    return ch;
}
