/* Copyright (c) 2014 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor vl_metronom.c */

#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>

#include "lib.h"
#include "definice.h"
#include "http/check-new-version.h"

void *vl_http_version(void *arg)
{
    int i;
    char *version;
    i = pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
    if (i && (global_get(g_warning) == g_w_ano)) {
        print_hl(1,
                 "vl_http_version: Selhalo nastaveni priznaku ukonceni funkce varovani");
        return NULL;
    }
    if (httpCheckNewVersion(&version, global_get(g_warning))) {
        char *ram = "****************************************************";
        print_hl(1, ram);
        print_hl(7, "* Byla nalezena nova verze ", NAZEV1, ": ", VER,
                 " => ", version, " *");
        print_hl(1, ram);
    } else if (version) {
        if (global_get(g_w_ano))
            print_hl(3, "Program ", NAZEV1, " je aktualni.");
    }


    pthread_exit(0);
}
