/* Copyright (c) 2004 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne licenese GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor vypis_napoveda.c */

#include <unistd.h>
#include <stdlib.h>
#include <limits.h>
#include "strukturyw.h"
#include "struktury.h"
#include "lib.h"
#include "libw.h"
#include "barvy.h"

void vypis_napoveda(char *jmeno, boolean test)
{
    FILE *soubor;
    char radek[80];
    int r = 1;

    wattron2(sub_hlavni, COLOR_PAIR(COLOR_NAPOVEDALT_HLAVNI) | A_BOLD);
    werase2(sub_hlavni);

    if ((soubor = fopen(jmeno, "rt")) == NULL) {
        if (test)
            mvwprintw2(sub_hlavni, 2, 2,
                       " NPOVDA K TOMUTO TESTU NEN K DISPOZICI");
        else
            mvwprintw2(sub_hlavni, 2, 2,
                       "NPOVDA K TTO LEKCI NEN K DISPOZICI");
        obnov_hlavni();
        wattroff(sub_hlavni, A_BOLD);
        if (test)
            mvwprintw2(sub_hlavni, 0, 1,
                       " <Tab> = informace o testu, <ENTER> = psan testu ");
        else
            mvwprintw2(sub_hlavni, 0, 1,
                       " <Tab> = informace o lekci, <ENTER> = psan lekce ");
        return;
    }

    while ((fgets(radek, (COLS - 13 < 80) ? (COLS - 13) : 80, soubor)) !=
           NULL) {
        radek[strlen(radek) - 1] = '\0';
        mvwprintw2(sub_hlavni, r++, 1, radek);
    }

    wattroff(sub_hlavni, A_BOLD);
    obnov_hlavni();
    if (test) {
        mvwprintw2(sub_hlavni, 0, 1,
                   " <Tab> = informace o testu, <ENTER> = psan testu ");
    } else {
        mvwprintw2(sub_hlavni, 0, 1,
                   " <Tab> = informace o lekci, <ENTER> = psan lekce ");
    }
    if (fclose(soubor)
        && (global_get(g_warning) == g_w_ano))
        perror("fclose");
}
